import Flutter
import UIKit

public class SwiftBlotoutfluttersdkPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "blotoutfluttersdk", binaryMessenger: registrar.messenger())
    let instance = SwiftBlotoutfluttersdkPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    
    switch call.method {
    case MethodName.Initialize_SDK.rawValue:
      self.initializeAnalyticsEngine(call: call, result: result);
      break;
    case MethodName.Update_Blotout_SDK.rawValue:
      self.updateAnalyticsEngineTest(call: call, result:result);
     break;
    case MethodName.Start_Timed_Event.rawValue:
    self.startTimedEvent(call: call, result:result);
     break;
      case MethodName.End_Timed_Event.rawValue:
      self.endTimedEvent(call: call, result:result);
     break;
      case MethodName.Log_Event.rawValue:
      self.logEvent(call: call, result:result);
     break;
      case MethodName.Log_Event_With_Time.rawValue:
      self.logEventWithTime(call: call, result:result);
     break;
      case MethodName.Log_PII_Event.rawValue:
      self.logPIIEvent(call: call, result:result);
     break;
      case MethodName.Log_PHI_Event.rawValue:
      self.logPHIEvent(call: call, result:result);
     break;
       case MethodName.Set_SDK_End_Point_Url.rawValue:
       
     break;
       case MethodName.Set_SDK_Enabled.rawValue:
       
     break;

    default:
      break;
    }
  }
}


extension SwiftBlotoutfluttersdkPlugin {
 
    enum MethodName: String, CaseIterable {
       case Initialize_SDK = "initBlotoutSDK"
       case Update_Blotout_SDK = "updateBlotoutSDK"
       case Start_Timed_Event = "startTimedEvent"
       case End_Timed_Event = "endTimedEvent"
       case Log_Event = "logEvent"
       case Log_Event_With_Time = "logEventWithTime"
       case Log_User_Retention_Event = "logUserRetentionEvent"
       case Log_PII_Event = "logPIIEvent"
       case Log_PHI_Event = "logPHIEvent"
       
        case Set_SDK_End_Point_Url = "setSDKEndPointUrl"
        case Set_SDK_Enabled = "setSDKEnabled"
        case Set_Network_Sync_Enabled = "setNetworkSyncEnabled"
        case Set_Data_Collection_Enabled = "setDataCollectionEnabled"
        case Set_Funnel_Events_Enabled = "setFunnelEventsEnabled"
        case Set_Segment_Events_Enabled = "setSegmentEventsEnabled"
        case Set_System_Events_Enabled = "setSystemEventsEnabled"
        case Set_Developer_Events_Enabled = "setDeveloperEventsEnabled"

        case IS_Device_Compromised = "isDeviceCompromised"
        case IS_App_Compromised = "isAppCompromised"
        case IS_Network_Proxied = "isNetworkProxied"
        case IS_Simulator = "isSimulator"
        case IS_Running_On_VM = "isRunningOnVM"
        case IS_Environment_Secure = "isEnvironmentSecure"
    }
}

extension SwiftBlotoutfluttersdkPlugin {

  private func initializeAnalyticsEngine(call: FlutterMethodCall, result: @escaping FlutterResult){
    
    if let arguments = call.arguments as? [String:Any] {
        
        if let token = arguments["testKey"] as? String {
            
            BlotoutAnalytics.sharedInstance()?.initializeAnalyticsEngine(usingTest: token, andProduction: token, inProductionMode: false, withCompletionHandler: { (success, error) in
                if(success) {
                    return result(true)
                } else {
                    return result(false)
                }
            })
        }
    }
  }


/*
 * @param blotoutTestKey stage key as String
 * @param blotoutProductionKey production key as String
 */
private func updateAnalyticsEngineTest(call: FlutterMethodCall, result: @escaping FlutterResult) {
  
}

/*
 * @param eventName name of the event
 * @param startEventInfo properties in key/value pair
 */
private func startTimedEvent(call: FlutterMethodCall, result: @escaping FlutterResult) {
  
}

/*
 * @param eventName name of the event
 * @param endEventInfo properties in key/value pair
 */
private func endTimedEvent(call: FlutterMethodCall, result: @escaping FlutterResult){
  
}

/*
 * @param eventName name of the event
 * @param eventInfo properties in key/value pair
 */
private func logEvent(call: FlutterMethodCall, result: @escaping FlutterResult) {
  
}

/*
 * @param eventName name of the event as String
 * @param eventInfo properties in key/value pair
 * @param eventTime eventTime as Date
 */
private func logEventWithTime(call: FlutterMethodCall, result: @escaping FlutterResult){
 
}

/*
 * @param eventName name of the event as String
 * @param eventInfo properties in key/value pair
 */
private func logUserRetentionEvent(call: FlutterMethodCall, result: @escaping FlutterResult){
  
}

/*
 * @param eventName name of the event as String
 * @param eventInfo properties in key/value pair
 */
private func logPIIEvent(call: FlutterMethodCall, result: @escaping FlutterResult){
  
}

/*
 * @param eventName name of the event as String
 * @param eventInfo properties in key/value pair
 */
private func logPHIEvent(call: FlutterMethodCall, result: @escaping FlutterResult){
  
}

/**
 * SDK Endpoint Url must be set before Analytics Engine Initialization, It has to be a domain based IP's are considered invalid.
 * @param endPointUrl 
 */
}
